@ECHO OFF
REM -------------------------------------------------------
REM Arguments -- config file
REM -------------------------------------------------------

set version=.v2_1

set force=n
set cdrom=n

if NOT %1%==-F goto endif1
    set force=y
    shift
:endif1

if NOT %1%==-c goto endif2
    set cdrom=y
    set cdpath=%2%
    shift
    shift
:endif2

set config=%1%

if exist %config% goto haveconfig

if exist %config%.txt goto haveconfigtxt

echo "Config file %config% does not exist"
goto end

:haveconfigtxt

set config=%config%.txt

:haveconfig

REM -------------------------------------------------------
REM Overwrite checks 
REM -------------------------------------------------------
REM check for existing databases, etc.

REM clean out reasons we cant run file
if exist %TEMP%\reasons.txt erase %TEMP%\reasons.txt

REM check for valid HOME parts
if %HOMEPATH%== echo  * HOMEPATH is not set or is a null string >> %TEMP%\reasons.txt

REM look all over for ups databses and setups files we might have written

for %%d in ( \fnal\ups \local\ups ) do if exist C:%%d\db echo  * ups products database area already exists under C:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\products \D0RunII\d0usr\products \D0RunII\d0usr\products \D0RunII\d0dist\dist \d0fermi\products \p\cluster_disk \products ) do if exist C:%%d\upsdb echo  * ups products database area already exists under C:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\local\etc\setups \local\ups\etc\setups \fnal\ups\etc\setups ) do if exist C:%%d\setups.csh echo * ups setups scripts exist in directory C:%%d >> %TEMP%\reasons.txt

for %%d in ( \fnal\ups \local\ups ) do if exist D:%%d\db echo  * ups products database area already exists under D:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\products \D0RunII\d0usr\products \D0RunII\d0usr\products \D0RunII\d0dist\dist \d0fermi\products \p\cluster_disk \products ) do if exist D:%%d\upsdb echo  * ups products database area already exists under D:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\local\etc\setups \local\ups\etc\setups \fnal\ups\etc\setups ) do if exist D:%%d\setups.csh echo * ups setups scripts exist in directory D:%%d >> %TEMP%\reasons.txt

for %%d in ( \fnal\ups \local\ups ) do if exist E:%%d\db echo  * ups products database area already exists under E:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\products \D0RunII\d0usr\products \D0RunII\d0usr\products \D0RunII\d0dist\dist \d0fermi\products \p\cluster_disk \products ) do if exist E:%%d\upsdb echo  * ups products database area already exists under E:%%d >> %TEMP%\reasons.txt

for %%d in ( \usr\local\etc\setups \local\ups\etc\setups \fnal\ups\etc\setups ) do if exist E:%%d\setups.csh echo * ups setups scripts exist in directory E:%%d >> %TEMP%\reasons.txt

if not exist %TEMP%\reasons.txt goto okay

    echo "The bootstrap cannot proceed because:"
    type %TEMP%\reasons.txt
    if %force%==y goto doitanyway

    echo "These directories must be cleaned out before the bootstrap can run"
    goto end

:doitanyway
    echo "But since you specified -F, onward...

:okay

if "%2%" EQU "noredirect" goto doit

REM -------------------------------------
REM percent done monitor
REM

echo var WSHShell = WScript.CreateObject("WScript.Shell");      > %TEMP%\monitor.js
echo var fso = new ActiveXObject("Scripting.FileSystemObject"); >> %TEMP%\monitor.js
echo var stdout = fso.CreateTextFile("CON:", true);             >> %TEMP%\monitor.js
echo var f;                                                     >> %TEMP%\monitor.js
echo var size;                                                  >> %TEMP%\monitor.js
echo var expected = 732000;                                     >> %TEMP%\monitor.js
echo while( fso.fileExists("%TEMP:\=\\%\\keepmon") ) {          >> %TEMP%\monitor.js
echo     f = fso.getFile("%TEMP:\=\\%\\bootups.log");           >> %TEMP%\monitor.js
echo     size = f.Size;                                         >> %TEMP%\monitor.js
echo     prcnt = Math.ceil(size * 100 / expected);              >> %TEMP%\monitor.js
echo     stdout.Write(prcnt + "%% completed   \r");             >> %TEMP%\monitor.js
echo }                                                          >> %TEMP%\monitor.js

echo > %TEMP%\keepmon
echo > %TEMP%\bootups.log

start /low "BootstrapMonitor" cscript %TEMP%\monitor.js

REM ------------------ Log Output --------------------
echo Redirecting output to %TEMP%\bootups.log
call stage1.bat %config% noredirect > %TEMP%\bootups.log 2>&1
@echo off
goto whathappened

:doit

ECHO ON

REM -------------------------------------------------------
REM clean up temp area in case this is a re-run
REM -------------------------------------------------------
if exist %TEMP%\bootups rmdir /q /s %TEMP%\bootups

REM -------------------------------------------------------
REM Copy our config file to our scratch area so we can find 
REM it later...
REM -------------------------------------------------------
mkdir %TEMP%\bootups
copy %config% %TEMP%\bootups\%config%

REM -------------------------------------------------------
REM Switch drive/dir to TEMP
REM -------------------------------------------------------
%TEMP:~0,2%
cd %TEMP%\bootups


REM -------------------------------------------------------
REM Setup our utils area, and our mkftpscript.bat file
REM -------------------------------------------------------
mkdir utils
cd utils
set PATH=%TEMP%\bootups\utils;%PATH%

echo echo user ftp>mkftpscript.bat
echo echo boot@%COMPUTERNAME%>>mkftpscript.bat
echo echo binary>>mkftpscript.bat
echo echo prompt>>mkftpscript.bat
echo echo hash>>mkftpscript.bat
echo echo cd %%1%%>>mkftpscript.bat
echo echo mget %%2%%>>mkftpscript.bat
echo echo bye>>mkftpscript.bat


echo off
call mkftpscript /products/cygboot/v1_0/utils *.* > ftpscript
call mkftpscript /products/bootstrap/tarfiles CYGWIN32_NT.tar.gz >ftpscript2
call mkftpscript /products/bootstrap/%version% stage2.sh >ftpscript3
echo on

REM -------------------------------------------------------
REM Use mkftpscript to get our other utils, which will
REM be tar, gzip, and cygwin.dll
REM -------------------------------------------------------
if %cdrom%==y goto elsecdrom1

    ftp -v -n -s:ftpscript ftp.fnal.gov

goto endifcdrom1
:elsecdrom1

    copy %cdpath%/cygboot/utils/*.* 

:endifcdrom1

cd ..

REM -------------------------------------------------------
REM clean up any past attempts
REM -------------------------------------------------------
kill_registry_entries.exe "Cygnus Solutions"


REM -------------------------------------------------------
REM Now that our utils area is setup, get the big tarfile
REM and unpack it
REM  then
REM get stage2.sh script (may go away once its stable)
REM -------------------------------------------------------

if %cdrom%==y goto elsecdrom2
    ftp -v -n -s:utils\ftpscript2 ftp.fnal.gov
    tar xvzf CYGWIN32_NT.tar.gz
    erase CYGWIN32_NT.tar.gz

    ftp -v -n -s:utils\ftpscript3 ftp.fnal.gov
goto endifcdrom2
:elsecdrom2

    tar xzvf %cdpath%\tarfiles\CYGWIN32_NT.tar.gz
    copy %cdpath%\prd\bootstrap\%version%\stage2.sh

:endifcdrom2

REM -------------------------------------------------------
REM find the bin directory
REM -------------------------------------------------------
cd prd
cd cygwin32
cd B*
cd v*
cd C*
cd H*
cd bin

REM -------------------------------------------------------
REM Write a simple bash script to get our CYGWIN environment 
REM enough to use ups configure on cygwin32, then run the 
REM stage2 script
REM -------------------------------------------------------
echo #!/bin/sh>> %TEMP%/bootups/runit
echo set -x >> %TEMP%/bootups/runit
echo export PATH=`pwd`:$PATH>> %TEMP%/bootups/runit
echo mount `cygpath -w $PWD` /bin>> %TEMP%/bootups/runit
echo mount "$TEMP" /var/tmp>> %TEMP%/bootups/runit
echo mount "$TEMP" /tmp>> %TEMP%/bootups/runit
echo . /var/tmp/bootups/etc/setups.sh>> %TEMP%/bootups/runit
echo cd /var/tmp/bootups>> %TEMP%/bootups/runit
echo ups configure cygwin32>> %TEMP%/bootups/runit
echo setup cygwin32>> %TEMP%/bootups/runit
echo sh -x ./stage2.sh %config% /var/tmp/bootups>> %TEMP%/bootups/runit

REM -------------------------------------------------------
REM Actually run the bash script
REM -------------------------------------------------------
bash.exe -c "./bash `./cygpath -u '%TEMP%\bootups\runit'`"

goto end

:whathappened
if %ERRORLEVEL%==0 goto success

erase %TEMP%\keepmon
echo Bootstrap failed. Please mail %TEMP%\bootups.log to uas-group@fnal.gov
goto cleanup

:success
  
erase %TEMP%\keepmon
REM erase %TEMP%\bootups.log
echo Bootstrap succeeded!

REM -------------------------------------------------------
REM This should be it...  Nothing to do but clean up.
REM -------------------------------------------------------
:cleanup
cd %TEMP%
rmdir /q /s bootups

:end
